﻿Imports SlimDX
Imports SlimDX.Direct3D9
Imports SlimDX.DirectInput
Imports sdxBaseEngine


Public Class Project : Inherits SDX9BaseEngine


    Public Sub New()

        AddHandler dxRenderScene, AddressOf render
        AddHandler dxKeyboardState, AddressOf keyboard
        AddHandler dxMouseState, AddressOf mouse
        AddHandler dxLoadObjectsSettings, AddressOf LoadObjectsSettings
        AddHandler dxLoadObjectsTextures, AddressOf LoadObjectsTextures
        AddHandler dxEngineClosed, AddressOf ExitAplication

        '---------------------------------------------
        '# set CooporateLevels if you like to
        '---------------------------------------------

        'dxEngine.KeyboardSetCooperativeLevel = CooperativeLevel.Exclusive Or CooperativeLevel.Foreground
        'dxEngine.MouseSetCooperativeLevel = CooperativeLevel.Exclusive Or CooperativeLevel.Foreground

        If Me.dxEngine("SlimDX - SDX9 EmptyProject") = False Then CloseBaseEngine()
    End Sub

#Region "## Loading ObjectsSettings ##"
    Private Sub LoadObjectsSettings()
        '---------------------------------------------
        '# Load all Objects and Settings
        '---------------------------------------------
    End Sub
#End Region

#Region "## Loading ObjectsTextures ##"
    Private Sub LoadObjectsTextures()
        '---------------------------------------------
        '# Load all Textures that have to 
        '# be Reloaded if Device is lost
        '---------------------------------------------
    End Sub
#End Region

#Region "## Render ##"
    Private Sub render()
        '---------------------------------------------
        '# Draw all things you have loaded 
        '---------------------------------------------
        dx2DText.DrawFPS()
    End Sub


#End Region
#Region "## Inputdevices ##"
    Private Sub keyboard()
        '---------------------------------------------
        '# Do all Keybordinputs here
        '---------------------------------------------
        If dxEngine.KeyPressed(Key.Escape) Then CloseBaseEngine()
    End Sub

    Private Sub mouse()
        '---------------------------------------------
        '# Do all Mouseinputs here
        '---------------------------------------------
    End Sub
#End Region

#Region "Exit App"
    Private Sub ExitAplication()
        '---------------------------------------------
        '# Place all none EngineObjects here 
        '# for Disposing.
        '# All EngineObjects Dispose automaticly
        '---------------------------------------------
        If dxEngine.EngineError Then
            Me.Hide()
            MsgBox(dxEngine.EngineErrorDescription, MsgBoxStyle.Critical)
        End If
        End
    End Sub
#End Region
End Class
